"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const plugin_vue_1 = __importDefault(require("@vitejs/plugin-vue"));
const plugin_vue_jsx_1 = __importDefault(require("@vitejs/plugin-vue-jsx"));
const vite_plugin_external_1 = __importDefault(require("../plugins/vite-plugin-external"));
const vite_plugin_build_virtual_1 = __importDefault(require("../plugins/vite-plugin-build-virtual"));
const config = {
    mode: 'production',
    configFile: false,
    build: {
        target: 'modules',
        outDir: 'dist',
        emptyOutDir: false,
        minify: false,
        rollupOptions: {
            // external:['vue'],
            input: ['src/index.ts'],
            output: [
                {
                    format: 'es',
                    dir: 'es',
                    entryFileNames: '[name].js',
                    preserveModules: true,
                    // preserveModulesRoot: 'components',
                },
                {
                    format: 'commonjs',
                    dir: 'lib',
                    entryFileNames: '[name].js',
                    preserveModules: true,
                    // preserveModulesRoot: 'components',
                },
            ],
        },
        // 开启lib模式，但不使用下面配置
        lib: {
            entry: '',
            formats: ['es', 'cjs'],
        },
    },
    // @ts-ignore vite内部类型错误
    plugins: [(0, vite_plugin_external_1.default)(), (0, plugin_vue_1.default)(), (0, plugin_vue_jsx_1.default)(), (0, vite_plugin_build_virtual_1.default)()],
    // plugins:[external(), vue(), vueJsx()]
};
exports.default = config;
