"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/*
 * @Author: saber
 * @Date: 2021-12-24 16:08:42
 * @LastEditTime: 2021-12-28 21:41:03
 * @LastEditors: saber
 * @Description:
 */
const path_1 = __importDefault(require("path"));
const fs_extra_1 = __importDefault(require("fs-extra"));
const commander_1 = require("commander");
const build_component_1 = __importDefault(require("./scripts/build-component"));
const build_style_1 = __importDefault(require("./scripts/build-style"));
function default_1() {
    const program = new commander_1.Command();
    const packageContent = fs_extra_1.default.readFileSync(path_1.default.resolve(__dirname, '../package.json'), 'utf8');
    const packageData = JSON.parse(packageContent);
    program
        .version(packageData.version)
        .name('dango-vue')
        .usage('command [options]');
    program
        .command('build:component')
        .description('构建组件')
        .action(() => __awaiter(this, void 0, void 0, function* () {
        try {
            yield (0, build_component_1.default)();
        }
        catch (err) {
            console.error(err);
        }
    }));
    program
        .command('build:style')
        .description('编译style的目录')
        .action(() => __awaiter(this, void 0, void 0, function* () {
        try {
            yield (0, build_style_1.default)();
        }
        catch (err) {
            console.error(err);
        }
    }));
    program.parse(process.argv);
}
exports.default = default_1;
