"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/*
 * @Author: saber
 * @Date: 2021-12-28 15:25:50
 * @LastEditTime: 2021-12-30 14:43:54
 * @LastEditors: saber
 * @Description:
 */
const glob_1 = __importDefault(require("glob"));
const path_1 = __importDefault(require("path"));
const fs_extra_1 = __importDefault(require("fs-extra"));
const sass_1 = __importDefault(require("sass"));
const postcss_1 = __importDefault(require("postcss"));
const autoprefixer_1 = __importDefault(require("autoprefixer"));
const paths_1 = __importDefault(require("../../utils/paths"));
const vite_1 = require("vite");
const vite_prod_style_1 = __importDefault(require("../../configs/vite.prod.style"));
// , "last 2 versions"
const browserslist = ['> 1%', "not ie 11", "not op_mini all"];
const processors = [
    (0, autoprefixer_1.default)(browserslist),
    // autoprefixer({
    //   overrideBrowserslist: browserslist
    // })
];
const root = process.cwd();
// TODO: 这里能兼容 单组件库 和 多组件吗
const run = () => __awaiter(void 0, void 0, void 0, function* () {
    // 查找文件
    const files = glob_1.default.sync('**/*.{scss,js}', {
        cwd: path_1.default.resolve(root, 'src'),
    });
    for (const filename of files) {
        const absolute = paths_1.default.resolvePath(`src/${filename}`);
        // 拷贝源代码
        fs_extra_1.default.copySync(absolute, paths_1.default.resolvePath(`es/${filename}`));
        fs_extra_1.default.copySync(absolute, paths_1.default.resolvePath(`lib/${filename}`));
        // 编译sass到css
        if (/index\.scss$/.test(filename)) {
            console.log(`开始编译: ${filename}`);
            const result = yield sass_1.default.compileAsync(absolute);
            const pcss = yield (0, postcss_1.default)(processors).process(result.css, {
                from: undefined,
            });
            const cssFilename = filename.replace('.scss', '.css');
            fs_extra_1.default.writeFileSync(paths_1.default.resolvePath(`es/${cssFilename}`), pcss.css);
            fs_extra_1.default.writeFileSync(paths_1.default.resolvePath(`lib/${cssFilename}`), pcss.css);
            console.log(`${filename} 构建成功`);
        }
    }
    // 构建 style/index.ts
    const buildIndex = () => __awaiter(void 0, void 0, void 0, function* () {
        yield (0, vite_1.build)(vite_prod_style_1.default);
    });
    yield buildIndex();
});
exports.default = run;
